{Copyright by RomaSoft 1996}
Uses crt;
Const DmaChannel : Array [0..3,1..3] of Byte =
  (($87,$0,$1),($83,$2,$3),($81,$2,$3),($82,$6,$7));
Var   Reset, ReadData, WriteData, DataAvailable : Word;
      Offset, Page                              : Word;
Function InitSoundSystem(Base : Word) : Byte;
Begin
 InitSoundSystem := 1;
 Base := Base * $10;
 Reset := Base + $206;
 ReadData := Base + $20A;
 WriteData := Base + $20C;
 DataAvailable := Base + $20E;
 Port[Reset] := 1;
 Delay(1);
 Port[Reset] := 0;
 Delay(1);
 If (Port[DataAvailable] And $80 = $80) And (Port[ReadData] = $AA) then Begin
  InitSoundSystem := 0;
 End;
End;
Procedure WriteDSP(Data : Byte);
Begin
 While Port[WriteData] And $80 <> 0 Do;
 Port[WriteData] := Data;
End;
Function ReadDSP : Byte;
Begin
 While Port[DataAvailable] And $80 = 0 Do;
 ReadDSP := Port[ReadData];
End;
Procedure SpeakerOn;
Begin
 WriteDSP($D1);
End;
Procedure SpeakerOff;
Begin
 WriteDSP($D3);
End;
Procedure DMAStop;
Begin
 WriteDSP($D0);
End;
Procedure DMAContinue;
Begin
 WriteDSP($D4);
End;
Procedure PlaySample(Sample : Pointer; Size : Word; Freq : Word; DMACh : Byte);
Begin
 SpeakerOn;
 Dec(Size);
 Offset := Seg(Sample^) Shl 4 + Ofs(Sample^);
 Page := (Seg(Sample^) + Ofs(Sample^) Shr 4) Shr 12;
 Port[$0A] := $4 + DMACh;
 Port[$0C] := 0; {Clear the internal DMA flip-flop}
 Port[$0B] := $48 + DMACh;
 Port[DMAChannel[1,2]] := Lo(Offset);
 Port[DMAChannel[1,2]] := Hi(Offset);
 Port[DMAChannel[1,1]] := Page;
 Port[DMAChannel[1,3]] := Lo(Size);
 Port[DMAChannel[1,3]] := Hi(Size);
 Port[$0A] := DMACh;
 WriteDSP($40);
 WriteDSP(256 - 1000000 Div Freq);
 WriteDSP($14);
 WriteDSP(Lo(Size));
 WriteDSP(Hi(Size));
End;
Begin
 Writeln('RomaSoft "Init sound system." version 0.1b. ');
 If InitSoundSystem($2) <> 0 then Writeln('Error in initializing soundcard !')
 else Writeln('Sound card found !');
  PlaySample(Ptr($B800,0),65535,14000,1); {Plays data from video memory through SB!}
 End.